MODULE Keyboard; (* nonportable (i80x86) *)
IMPORT
  SYSTEM, Sys := Lowlevel;

CONST
  NoKeys* = CHR(0);
  AnyKey* = CHR(0);
  Up*     = CHR(48H);
  Left*   = CHR(4BH);
  Right*  = CHR(4DH);
  Down*   = CHR(50H);
  Esc*    = CHR(01H);
  Key1*   = CHR(02H);
  Key2*   = CHR(03H);
  Key3*   = CHR(04H);
  Key4*   = CHR(05H);
  Key5*   = CHR(06H);
  Key6*   = CHR(07H);
  Key7*   = CHR(08H);
  Key8*   = CHR(09H);
TYPE
  KEY* = CHAR;
  HANDLER = Sys.ADDRESS;
VAR
  oldInt9: HANDLER;
  keyMap: ARRAY 128 OF BOOLEAN;
  i: INTEGER;

PROCEDURE NewInt9* ;
BEGIN
  SYSTEM.CODE(
    50H,           (* push ax    *)
    53H,           (* push bx    *)
    06H,           (* push es    *)
    0FAH,          (* cli        *)
    0BBH,0,0,      (* mov bx,offset keyMap  *)  (* Get keyMap addr *)
    90H,           (* nop        *)
    0B8H,0,0,      (* mov ax,segment keyMap *)
    8EH,0C0H,      (* mov es,ax  *)
    0E4H,60H,      (* in al,60h  *)
    32H,0E4H,      (* xor ah,ah; FALSE  *)
    0A8H,80H,      (* test al,80h       *)
    75H,02H,       (* jnz short release *)
    0B4H,01H,      (* mov ah,1 ; TRUE   *)
            (* release: *)
    24H,7FH,       (* and al,7Fh *)
    02H,0D8H,      (* add bl,al  *)
    80H,0D7H,00H,  (* adc bh,0   *)
    26H,88H,27H,   (* mov es:[bx],ah    *)
    33H,0C0H,      (* xor ax,ax  *)       (* Clear keyboard buffer *)
    8EH,0C0H,      (* mov es,ax  *)
    26H,0A0H,1AH,4,(* mov al,es:[41Ah]  *)
    26H,0A2H,1CH,4,(* mov es:[41ch],al  *)
    0FBH,          (* sti        *)
    9CH,           (* pushf      *)               (* Call old Int9 *)
    9AH,0,0,0,0,   (* call far ptr oldInt9 *)
    07H,           (* pop es     *)
    5BH,           (* pop bx     *)
    58H,           (* pop ax     *)
    0CFH           (* iret       *)
  )
END NewInt9;

PROCEDURE GetInt9 (VAR handler: HANDLER);
BEGIN
  SYSTEM.CODE(
    0B8H,09H,35H,(* mov ax,3509h *)
    0CDH,21H,    (* int 21h      *)
    08CH,0C0H,   (* mov ax,es    *)
    0C4H,7EH,04H,(* les di,dword ptr [bp+4] *)
    0FCH,        (* cld          *)
    093H,        (* xchg ax,bx   *)
    0ABH,        (* stosw        *)
    093H,        (* xchg ax,bx   *)
    0ABH         (* stosw        *)
  )
END GetInt9;

PROCEDURE SetInt9 (newInt9: HANDLER);
BEGIN
  SYSTEM.CODE(
    1EH,         (* push ds      *)
    0C5H,56H,04H,(* lds dx,dword ptr [bp+4];newInt9 *)
    0B8H,09H,25H,(* mov ax,2509h *)
    0CDH,21H,    (* int 21h      *)
    1FH          (* pop ds       *)
  )
END SetInt9;

PROCEDURE Pressed* (key: KEY): BOOLEAN;
BEGIN
  IF key < CHR(128) THEN RETURN keyMap[ORD(key)] END;
  RETURN FALSE
END Pressed;

PROCEDURE Release* (key: KEY);
BEGIN
  IF key < CHR(128) THEN keyMap[ORD(key)] := FALSE END
END Release;

PROCEDURE KeyPressed* (): BOOLEAN;
BEGIN
  SYSTEM.CODE(
    0B4H,01H,    (* mov ah,1h    *)
    0CDH,16H,    (* int 16h      *)
    75H,04H,     (* jnz pressed  *)
    33H,0C0H,    (* xor ax,ax    *)
    7AH,03H      (* jp RET_FALSE *)
  );
    (* pressed: *)
  RETURN TRUE;
    (*RET_FALSE:*)
END KeyPressed;

PROCEDURE ReadKey* (): CHAR;
BEGIN
  SYSTEM.CODE(
    0B4H,00H,    (* mov ah,0h    *)
    0CDH,16H,    (* int 16h      *)
    7AH,03H      (* jp exit_proc *)
  );
  RETURN CHR(0)
  (* exit_proc: *)
END ReadKey;

PROCEDURE Close* ;
BEGIN
  SetInt9(oldInt9)
END Close;

BEGIN
  GetInt9(oldInt9);
  SYSTEM.PUT(Sys.MakeAddr(NewInt9)+48, oldInt9); (*Patching new Int9 handler*)
  SYSTEM.PUT(Sys.MakeAddr(NewInt9)+ 5, SYSTEM.ADR(keyMap)); (*keyMap offset*)
  SYSTEM.PUT(Sys.MakeAddr(NewInt9)+ 7, SYSTEM.ADR(keyMap)); (*keyMap segment*)
  SYSTEM.PUT(Sys.MakeAddr(NewInt9)+ 7, 0B890H); (* nop; mov ax,n  *)
  SetInt9(Sys.MakeAddr(NewInt9));
  i := 128; REPEAT DEC(i); keyMap[i] := FALSE UNTIL i = 0

END Keyboard.
