MODULE Lowlevel; (* nonportable (i80x86) *)
IMPORT SYSTEM;

TYPE
  CARDINAL* = INTEGER; (* Unsigned and bit mask *)
  RESOURCE* = PROCEDURE; (* Pointer to resource *)
  ADDRESS*  = LONGINT;     (* Address (32 bits) *)

PROCEDURE AND* (a, b: CARDINAL): CARDINAL;
BEGIN
  SYSTEM.CODE(
    8BH,46H,08H, (* mov ax,word ptr[bp+8]; a *)
    8BH,5EH,06H, (* mov bx,word ptr[bp+6]; b *)
    23H,0C3H,    (* and ax,bx *)
    89H,46H,08H);(* mov word ptr[bp+8],ax; a *)
  RETURN a
END AND;

PROCEDURE LSH* (x: CARDINAL; n: SHORTINT): CARDINAL;
  (* Logical shift (n > 0: left, n < 0: right) *)
BEGIN
  IF n > 0 THEN SYSTEM.CODE(
    8BH,46H,08H, (* mov ax,word ptr[bp+8]; x *)
    8AH,4EH,06H, (* mov cl,byte ptr[bp+6]; n *)
    0D3H,0E0H,   (* shl ax,cl *)
    89H,46H,08H);(* mov word ptr[bp+8],ax; x *)
    RETURN x
  END;
  SYSTEM.CODE(
    8BH,46H,08H, (* mov ax,word ptr[bp+8]; x *)
    8BH,4EH,06H, (* mov cx,word ptr[bp+6]; n *)
    0F7H,0D9H,   (* neg cx *)
    0D3H,0E8H,   (* shr ax,cl *)
    89H,46H,08H);(* mov word ptr[bp+8],ax; x *)
  RETURN x
END LSH;

PROCEDURE MakeAddr* (proc: RESOURCE): ADDRESS;
VAR
  rsrc: RESOURCE;
BEGIN
  rsrc := proc;
  RETURN SYSTEM.VAL(ADDRESS,rsrc) + 4
END MakeAddr;

PROCEDURE GetByte* (addr: ADDRESS): SHORTINT;
BEGIN
  RETURN SHORT(SHORT(SYSTEM.GET(addr)))
END GetByte;

PROCEDURE GetInt* (addr: ADDRESS): INTEGER;
BEGIN
  RETURN SHORT(SYSTEM.GET(addr))
END GetInt;

PROCEDURE NextByte* (VAR addr: ADDRESS);
BEGIN
  addr := addr + 1
END NextByte;

END Lowlevel.
