MODULE Timer; (* nonportable (i80x86) *)
IMPORT SYSTEM;

CONST
  TicksPerMSec* = (10000 DIV 182)+1; (* 18.2 ticks per second *)
TYPE
  CARDINAL = INTEGER;
  TICKS* = CARDINAL;
VAR
  saveTicks: TICKS;

PROCEDURE GetTicks* (): TICKS;
VAR
  ticks: INTEGER;
BEGIN
  SYSTEM.CODE(
    0B8H,40H,00H,     (* mov ax,0040h *)
    8EH,0C0H,         (* mov es,ax *)
    26H,0A1H,6CH,00H, (* mov ax,word ptr es:6Ch *)
    89H,46H,0FCH      (* mov [bp-4],ax *)
  );
  RETURN ticks
END GetTicks;

PROCEDURE DelayTicks* (ticks: TICKS);
VAR
  t: TICKS;
BEGIN
  t := GetTicks();
  WHILE GetTicks() - t < ticks DO
    SYSTEM.CODE(0F4H) (* hlt *)
  END
END DelayTicks;

PROCEDURE RunDelay*;
BEGIN
  saveTicks := GetTicks()
END RunDelay;

PROCEDURE WaitDelay* (ticks: TICKS);
VAR
  t: TICKS;
BEGIN
  t := GetTicks() - saveTicks;
  IF ticks > t THEN DelayTicks(ticks - t) END
END WaitDelay;

END Timer.
